package lab;

import lab.storage.DbConnector;
import lab.storage.ScoreStorageInterface;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Builder.Default;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.ToString;

@Getter
@AllArgsConstructor
@EqualsAndHashCode
@ToString
@Builder(toBuilder = true)
public class Setup {

	@Getter
	private static Setup instance;

	@Default
	private ScoreStorageInterface scoreStorageInterface = new DbConnector();
	@Default
	private double lochnessMinXPopsition = 0.5;
	@Default
	private double lochnessMinYPopsition = 0.5;
	@Default
	private double lochnessMinSpeed = 50;
	@Default
	private double lochnessMaxSpeed = 150;
	@Default
	private int lochnessMultiplier = 1;
	@Default
	private double boatCollisionHeight = 0.25;
	@Default
	private double boatHitPulseX = 20;
	@Default
	private double boatHitPulseYMin = 50;
	@Default
	private double boatHitPulseYMax = 100;

	public static void configure(Setup setting) {
		instance = setting;
	}

	public static Setup getInstanceForHardcoreGame() {
		return builder().lochnessMaxSpeed(500).lochnessMinSpeed(200).lochnessMultiplier(10).lochnessMinYPopsition(0.1)
				.build();
	}

}
